{***************************************************************************}
{                              UNIDAD DE JUEGO

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UJuego;

INTERFACE

  USES
    ULista;

  CONST
    TipoPieza = 0;
    TipoPiezaJugador = 1;
    TipoPiezaControl = 2;
    TipoPiezaFicha = 3;
    TipoPiezaCuadro = 4;

  TYPE
    PPiezaJuego = ^OPiezaJuego;
      PPiezaJugador = ^OPiezaJugador;
      PPiezaControl = ^OPiezaControl;
        PControlTeclado = ^OControlTeclado;
      PPiezaCuadro = ^OPiezaCuadro;
        PCuadroHueco = ^OCuadroHueco;
    PJuego = ^OJuego;

    OPiezaJuego = OBJECT (OPiezaLista)
      Juego : PJuego;
      Tipo : Byte;
{Use @Self para NuevoJuego.}
      CONSTRUCTOR Inicia (NuevoJuego : PJuego);
    END;

      OPiezaJugador = OBJECT (OPiezaJuego)
        TurnosEspera,
        TurnosFaltan : Word;
        CONSTRUCTOR Inicia (NuevoJuego : PJuego);
        PROCEDURE Juega; VIRTUAL;
        PROCEDURE Turna; VIRTUAL;
      END;

        OJugadorControl = OBJECT (OPiezaJugador)
          Control : PPiezaControl;
          CONSTRUCTOR Inicia (NuevoJuego : PJuego);
        END;

      OPiezaControl = OBJECT (OPiezaJuego)
        Accion1,
        Accion2 : Boolean;
{Valores de Direccion:
       1
    8  |  2
     \ | /
  7 -- 0 -- 3
     / | \
    6  |  4
       5}
        Direccion : Byte;
        CONSTRUCTOR Inicia (NuevoJuego : PJuego);
        PROCEDURE Actualiza; VIRTUAL;
      END;

        OControlTeclado = OBJECT (OPiezaControl)
{Teclas configurables:}
          TeclaAccion1,
          TeclaAccion2,
          TeclaArriba,
          TeclaAbajo,
          TeclaIzquierda,
          TeclaDerecha : Byte;
          CONSTRUCTOR Inicia (NuevoJuego : PJuego);
          PROCEDURE AsignaTeclas (NuevaTeclaAccion1, NuevaTeclaAccion2,
            NuevaTeclaArriba, NuevaTeclaAbajo, NuevaTeclaIzquierda,
            NuevaTeclaDerecha : Byte);
          PROCEDURE Actualiza; VIRTUAL;
        END;

      OPiezaFicha = OBJECT (OPiezaJuego)
        X,
        Y : Integer;
        Accion,
        Direccion : Byte;
        CONSTRUCTOR Inicia (NuevoJuego : PJuego);
        PROCEDURE Mueve (Cantidad : Integer); VIRTUAL;
        PROCEDURE Gira (Cantidad : Integer); VIRTUAL;
        PROCEDURE Pega; VIRTUAL;
      END;

      OPiezaCuadro = OBJECT (OPiezaJuego)
        Pintura : Pointer;
        Ancho,
        Alto : Word;
        CONSTRUCTOR Inicia (NuevoJuego : PJuego);
        DESTRUCTOR Termina; VIRTUAL;
        PROCEDURE AsignaPintura (NuevaPintura : Pointer; NuevoAncho,
          NuevoAlto : Word);
        PROCEDURE Pega (X, Y : Integer); VIRTUAL;
      END;

        OCuadroHueco = OBJECT (OPiezaCuadro)
          Hueco : Byte;
          CONSTRUCTOR Inicia (NuevoJuego : PJuego);
          PROCEDURE AsignaPintura (NuevaPintura : Pointer; NuevoAncho,
            NuevoAlto : Word; NuevoHueco : Byte);
          PROCEDURE Pega (X, Y : Integer); VIRTUAL;
        END;

    OJuego = OBJECT (OLista)
      Fin : Boolean;
      TicsEspera : Word;
      CONSTRUCTOR Inicia;
      PROCEDURE TurnaJugadores; VIRTUAL;
      PROCEDURE ActualizaControles; VIRTUAL;
      PROCEDURE Juega; VIRTUAL;
    END;

IMPLEMENTATION

  USES
    UTeclado,
    UPintur1;

{***************************************************************************}

  CONSTRUCTOR OPiezaJuego. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia;
    Juego := NuevoJuego;
    Tipo := TipoPieza;
  END;

{***************************************************************************}

  CONSTRUCTOR OPiezaJugador. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Tipo := TipoPiezaJugador;
    TurnosEspera := 0;
    TurnosFaltan := 0;
  END;

  PROCEDURE OPiezaJugador. Juega;
  BEGIN
  END;

  PROCEDURE OPiezaJugador. Turna;
  BEGIN

    IF TurnosFaltan > 0 THEN Dec (TurnosFaltan) ELSE
    BEGIN
      Juega;
      TurnosFaltan := TurnosEspera;
    END;

  END;

{***************************************************************************}

  CONSTRUCTOR OJugadorControl. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Control := NIL;
  END;

{***************************************************************************}

  CONSTRUCTOR OPiezaControl. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Tipo := TipoPiezaControl;
    Accion1 := False;
    Accion2 := False;
    Direccion := 0;
  END;

  PROCEDURE OPiezaControl. Actualiza;
  BEGIN
  END;

{***************************************************************************}

  CONSTRUCTOR OControlTeclado. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    TeclaAccion1 := 0;
    TeclaAccion2 := 0;
    TeclaArriba := 0;
    TeclaAbajo := 0;
    TeclaIzquierda := 0;
    TeclaDerecha := 0;
  END;

  PROCEDURE OControlTeclado. AsignaTeclas (NuevaTeclaAccion1,
    NuevaTeclaAccion2, NuevaTeclaArriba, NuevaTeclaAbajo,
    NuevaTeclaIzquierda, NuevaTeclaDerecha : Byte);
  BEGIN
    TeclaAccion1 := NuevaTeclaAccion1;
    TeclaAccion2 := NuevaTeclaAccion2;
    TeclaArriba := NuevaTeclaArriba;
    TeclaAbajo := NuevaTeclaAbajo;
    TeclaIzquierda := NuevaTeclaIzquierda;
    TeclaDerecha := NuevaTeclaDerecha;
  END;

  PROCEDURE OControlTeclado. Actualiza;
  BEGIN
    Accion1 := Teclas [TeclaAccion1];
    Accion2 := Teclas [TeclaAccion2];

{Resuelve la Direccion segn el estado de cada tecla y su combinacin con
una tecla adyacente.}
    IF Teclas [TeclaArriba] THEN
    BEGIN
      IF Teclas [TeclaDerecha] THEN
        Direccion := 2
      ELSE
        IF Teclas [TeclaIzquierda] THEN
          Direccion := 8
        ELSE
          Direccion := 1;
    END ELSE
      IF Teclas [TeclaDerecha] THEN
      BEGIN
        IF Teclas [TeclaAbajo] THEN
          Direccion := 4
        ELSE
          Direccion := 3;
      END ELSE
        IF Teclas [TeclaAbajo] THEN
        BEGIN
          IF Teclas [TeclaIzquierda] THEN
            Direccion := 6
          ELSE
            Direccion := 5;
        END ELSE
          IF Teclas [TeclaIzquierda] THEN
          BEGIN
            Direccion := 7;
          END ELSE
          BEGIN
            Direccion := 0;
          END;

{Combinaciones que anulan la Direccion:}
    IF ((Teclas [TeclaArriba]) AND (Teclas [TeclaAbajo])) OR
      (Teclas [TeclaIzquierda]) AND (Teclas [TeclaDerecha]) THEN
      Direccion := 0;
  END;

{***************************************************************************}

  CONSTRUCTOR OPiezaFicha. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Tipo := TipoPiezaFicha;
    X := 0;
    Y := 0;
    Accion := 0;
    Direccion := 0;
  END;

  PROCEDURE OPiezaFicha. Mueve (Cantidad : Integer);
  BEGIN

    CASE Direccion OF
      1 : Dec (Y, Cantidad);

      2 : BEGIN
        Inc (X, Cantidad);
        Dec (Y, Cantidad);
      END;

      3 : Inc (X, Cantidad);

      4 : BEGIN
        Inc (X, Cantidad);
        Inc (Y, Cantidad);
      END;

      5 : Inc (Y, Cantidad);

      6 : BEGIN
        Dec (X, Cantidad);
        Inc (Y, Cantidad);
      END;

      7 : Dec (X, Cantidad);

      8 : BEGIN
        Dec (X, Cantidad);
        Dec (Y, Cantidad);
      END;

    END;

  END;

  PROCEDURE OPiezaFicha. Gira (Cantidad : Integer);

    VAR
      Resultado : Integer;

  BEGIN

    IF Direccion > 0 THEN
    BEGIN
      Resultado := ((Direccion - 1) + Cantidad) MOD 8;
      IF Resultado < 0 THEN Direccion := Resultado + 8 ELSE
        Direccion := Resultado + 1;
    END;

  END;

  PROCEDURE OPiezaFicha. Pega;
  BEGIN
  END;

{***************************************************************************}

  CONSTRUCTOR OPiezaCuadro. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Tipo := TipoPiezaCuadro;
    Pintura := NIL;
    Ancho := 0;
    Alto := 0;
  END;

  DESTRUCTOR OPiezaCuadro. Termina;
  BEGIN
    INHERITED Termina;
    IF Pintura <> NIL THEN FreeMem (Pintura, Ancho * Alto);
  END;

  PROCEDURE OPiezaCuadro. AsignaPintura (NuevaPintura : Pointer; NuevoAncho,
    NuevoAlto : Word);
  BEGIN
    Pintura := NuevaPintura;
    Ancho := NuevoAncho;
    Alto := NuevoAlto;
  END;

  PROCEDURE OPiezaCuadro. Pega (X, Y : Integer);
  BEGIN
    PegaCuadro (Pintura, Ancho, Alto, X, Y);
  END;

{***************************************************************************}

  CONSTRUCTOR OCuadroHueco. Inicia (NuevoJuego : PJuego);
  BEGIN
    INHERITED Inicia (NuevoJuego);
    Hueco := 0;
  END;

  PROCEDURE OCuadroHueco. AsignaPintura (NuevaPintura : Pointer; NuevoAncho,
    NuevoAlto : Word; NuevoHueco : Byte);
  BEGIN
    Pintura := NuevaPintura;
    Ancho := NuevoAncho;
    Alto := NuevoAlto;
    Hueco := NuevoHueco;
  END;

  PROCEDURE OCuadroHueco. Pega (X, Y : Integer);
  BEGIN
    PegaCuadroHueco (Pintura, Ancho, Alto, X, Y, Hueco);
  END;

{***************************************************************************}

  PROCEDURE OJuego. TurnaJugadores;
  BEGIN
    IniciaIndice;

    WHILE Indice <> NIL DO
    BEGIN
      IF PPiezaJuego (Indice)^. Tipo = TipoPiezaJugador THEN
        PPiezaJugador (Indice)^. Turna;
      AvanzaIndice;
    END;

  END;

  PROCEDURE OJuego. ActualizaControles;
  BEGIN
    IniciaIndice;

    WHILE Indice <> NIL DO
    BEGIN
      IF PPiezaJuego (Indice)^. Tipo = TipoPiezaControl THEN
        PPiezaControl (Indice)^. Actualiza;
      AvanzaIndice;
    END;

  END;

  CONSTRUCTOR OJuego. Inicia;
  BEGIN
    INHERITED Inicia;
    Fin := False;
    TicsEspera := 0;
  END;

  PROCEDURE OJuego. Juega;
  BEGIN
  END;

END.